

######################################################
#　　　石田　基広　著
#     『Rによるテキストマイニング入門』
#     森北出版,ISBN 978-4-627-84841-2,2008年12月
#
#      スクリプト
#       by Ishida Motohiro
#         
### R-2.9.0 以降をお使いの場合は R2MeCab_0.08 以降をご利用ください
#
# http://groups.google.co.jp/group/rmecab
# http://cms.ias.tokushima-u.ac.jp/index.php?RMeCab
#
# 本データには，図書に記載のないコードも含まれています．
#
#
# お問い合わせはこちらにメールをください
#
# ishida.motohiro@gmail.com
#
######################################################

########### R について 
# Macintosh版，Linux 版 R-2.8.0 には文字コードに関する
# 不具合があります． R-2.8.0 の場合，日本語を含むコードでは
# Encoding を指定する必要があります．
#  例 # Encoding(names(res2))<- "UTF-8"
#
# このスクリプトでは，その旨のコメントが記載されていますので
#  R-2.8.0 をご利用の方は，そのコメントにご注意ください．
# この不具合は R-2.8.1 では修正されています．
##################

######### シャープ(#)記号から右の記述はコメントです。
######### シャープ(#)記号から右は実行しても無視されます。


##### 作業フォルダを変更する必要があれば
# getwd() ## 現在のフォルダを確認する
##### 作業フォルダを変更する必要があれば
# setwd("C:/data") # Windows

setwd("/Users/ishidamotohiro/data") # Mac OS X
  ## Macintosh ユーザーの方は，本書に付属の data.tar.gz を解凍し，
  ## data フォルダ内の dot.Rprofile の名称を .Rprofile と変更して
  ## ホームフォルダに置いてください．
  ## Finder ではドットで始まるファイルを表示作成できないようなので
  ## ターミナルから
   $ mv dot.Rprofile .Rprofile
  #とします．



setwd("/home/ishida/data")# Linux


############ Macintosh ユーザーは次の手順で MeCab をインストールしてください．
## Mac OS X 10.5 には，はじめから MeCab がインストール済みのようです．
## /usr/lib にMeCabのライブラリ libmecab.dylib がありますので，
## そのパスが通っていれば，MeCab を改めてインストールする必要はありません．
## よく分からなければ，以下の手順で MeCab を別にインストールしてください．
## インストール先は別なので，上書きされることはありません．
 
###### なお，ファイルのダウンロードでは，Ctrl キーを押しながら
######ファイルをクリックしてください．さもないとファイル名が変更されてしまいます
######### 「リンク先のファイルをダウンロード」を選んでください．

		# MeCab 本体のインストール
# http://sourceforge.net/project/showfiles.php?group_id=177856&package_id=204917
		# 開発時の mecab のヴァージョンは 0.97 でした
		$ cd Downloads
		$ tar zxvf mecab-0.97.tar.gz 
		$ cd mecab-0.97
		$ ./configure --with-charset=utf8
		$ make
        $ chmod 700 install-sh
		$ sudo make install
        # $ sudo ldconfig # Linux ではこれが必要です
		# 辞書のインストール．開発時のヴァージョン 2.7.0-20070801 
		$ tar zxf mecab-ipadic-2.7.0-20070801.tar.gz
		$ cd mecab-ipadic-2.7.0-20070801
		$ ./configure --with-charset=utf8
        # エラーが出る場合は，PATHを通してみてください
        # 以下の一行を実行します．
        # $ export PATH=/usr/local/bin:PATH
		$ make
		$ sudo make install
        # 今後のために PATH を追加しておきます
        # $ echo $PATH
        # を実行して表示された内容に /usr/local/bin が含まれていない場合は
        # ホームディレクトリに戻って
        # $ cd
        # 次のコマンドを実行しておきます．
        # $ echo '/usr/local/bin:$PATH' >> .bash_profile
        # 引用符はシングルコーテーションです

## ubuntu 8.10 では  
## コンパイルを実行する前に g++-4.2をインストールした上で
## export GCC=g++-4.2
## export CC=gcc-4.2
## をあらかじめ実行しておく必要があるかもしれません．


###### Linux で R2MeCab をインストールする方法
 install.packages("R2MeCab_0.08.tar.gz", destdir=".",  repos = NULL)
# library(R2MeCab)

############ Mac ユーザーは次の手順で MeCab をインストールしてください．
## Mac OS X 10.5 には，はじめから MeCab がインストール済みのようです．
## /usr/lib にMeCabのライブラリ libmecab.dylib がありますので，
## そのパスが通っていれば，MeCab そのものをインストールする必要はありません．
## よく分からなければ，以下の手順で MeCab を別にインストールしてください．
## インストール先は別なので，上書きされることはありません． 

###### なお，ファイルのダウンロードでは，Ctrl キーを押しながら
######ファイルをクリックしてください．さもないとファイル名が変更されてしまいます
######### 「リンク先のファイルをダウンロード」を選んでください．


		# MeCab 本体のインストール
# http://sourceforge.net/project/showfiles.php?group_id=177856&package_id=204917
		# 開発時の mecab のヴァージョンは 0.97 でした
		$ cd Downloads
		$ tar zxvf mecab-0.97.tar.gz 
		$ cd mecab-0.97
		$ ./configure --with-charset=utf8
		$ make
		$ sudo make install
		# 辞書のインストール．開発時のヴァージョン 2.7.0-20070801 
		$ tar zxf mecab-ipadic-2.7.0-20070801.tar.gz
		$ cd mecab-ipadic-2.7.0-20070801
		$ ./configure --with-charset=utf8
        # エラーが出る場合は，PATHを通してみてください
        # 以下の一行を実行します．
        # $ export PATH=/usr/local/bin:PATH
		$ make
		$ sudo make install
        # 今後のために PATH を追加しておきます
        # $ echo $PATH
        # を実行して表示された内容に /usr/local/bin が含まれていない場合は
        # ホームディレクトリに戻って
        # $ cd
        # 次のコマンドを実行しておきます．
        # $ echo '/usr/local/bin:$PATH' >> .bash_profile
        # 引用符はシングルコーテーションです

 
## なおテキスト59ページのユーザー辞書の作成方法は Windows を対象とした説明です．
## Mac および Linux では http://mecab.sourceforge.net/dic.html の説明に従ってください．一部を以下の引用いたします．

##     * 適当なディレクトリに移動 (例: /home/foo/bar)
##     * foo.csv という辞書ファイルを作成（例はテキスト58ページのishida.csv）
##     * 辞書のコンパイル

##       % /usr/local/libexec/mecab/mecab-dict-index -d/usr/local/lib/mecab/dic/ipadic \
##       -u foo.dic -f utf8 -t utf8 foo.csv

##           o -d DIR: システム辞書があるディレクトリ
##           o -u FILE: FILE というユーザファイルを作成
##           o -f charset: CSVの文字コード
##           o -t charset: バイナリ辞書の文字コード 
##     * /home/foo/bar/foo.dic ができていることを確認
##     * /usr/local/lib/mecab/dic/ipadic/dicrc もしくは /usr/local/etc/mecabrc に以下を追加

##       userdic = /home/foo/bar/foo.dic 

##     * /usr/local/etc/mecabrc を編集する権限が無い場合は /usr/local/etc/mecabrc を ~/.mecabrc にコピーし, 上記のエントリを追加



# R から R2MeCab をインストールするには
# メニューから [パッケージとデータ]→[パッケージインストーラ]を選びます．一番上のCRANと表示されているメニューを[このコンピューター上のバイナリパッケージ]に変更します．右下の installボタンを押して，ダウンロードした R2MeCab_***.tgzを選びます．*** の部分はバージョン番号です．

## R-2.9.0 以降をお使いの場合は R2MeCab_0.08 以降をご利用ください．


 library(R2MeCab)



## RMeCabC 関数
res <- RMeCabC("すもももももももものうち")
res

res <- RMeCabC("Aを1個食べたいな")
res

res <- RMeCabC("ご飯を食べた", 1)
unlist(res)

res <- RMeCabC("ご飯を食べた", 0)
unlist(res)



res <- RMeCabC("すもももももももものうち")
  # Encoding( names(res[[1]]) )

res2 <- unlist(res)
res2

  ## <2008 11 18>
  ## Mac OS X, Linux で R-2.8.0 をお使いの方で
  ## 以下が正しく実行できない場合は次の1行ないし2行を実行してください
  #   Encoding(res2) <- "UTF-8"  ## これは必要ないと思います
  Encoding(names(res2))<- "UTF-8"
  ## なお，このバグはRの次のバージョンでは修正されているそうです．
  ### </ 2008 11 18>
  ##### ちなみに日本語Windowsで「もしも必要な場合は」 CP932 を指定します

res2[names(res2) == "名詞"]


res3 <- names(res2) == "名詞"

which(res3)
any(res3)




##############################################################################
## RMeCabText 関数 # ファイルから読み込む
# setwd("/Users/ishidamotohiro/data") # Mac OS X

res <- RMeCabText("yukiguni.txt")
res

res <- RMeCabText("/home/ishida/research/Tex/books/morikita/data/text.txt")
res


res <- RMeCabFreq("yukiguni.txt")
res

library(R2MeCab)
res <- RMeCabFreq("/home/ishida/research/Tex/books/morikita/data/text.txt")
res





##############################################################################
## RMeCabFreq 関数 ## 頻度表の作成
res <- RMeCabFreq("yukiguni.txt")
res

pt1 <- proc.time()
res <- RMeCabFreq("kumo.txt")
pt2 <- proc.time()
pt2 - pt1

res # 結果を確認



RMeCabC("何とも云えない")











##############################################################################
## RMeCabDF 関数 ###　データファイルの解析

dat <- read.csv("photo.csv")

colnames(dat)
res <- RMeCabDF(dat, 3) #res <- RMeCabDF(dat, "Reply") # に同じ
length(res)

res

res <- RMeCabDF(dat, 3, 1) #res <- RMeCabDF(dat, "Reply", 1) #  に同じ
length(res)

res








#  2009 年 3月 5日 新規追加
# docDF()関数 #
#
# 第 1 引数で指定されたファイル (フォルダが指定された場合は，その中の全ファイル)，あるいは第1引数でデータフレームを，また第 2 引数で列（番号あるいは名前）を指定して，Ngram行列，あるいはターム・文書行列を作成する．
## なお[[LESS-THAN-1]] と [[TOTAL-TOKENS]] の情報行は追加されない 
## 
##   指定可能な引数は
##      
## target 引数はファイル名ないしフォルダ名,あるいはデータフレーム
## column はデータフレームを指定し場合，列（番号あるいは名前）を指定する
## pos 引数は pos = c(``名詞'', ``形容詞'', ``記号'') のように指定する．デフォルトは全品詞
## minFreq 引数には頻度の閾値を指定するが
##           全テキストを通じての総頻度を判定対象とする．
##           例えば minFreq=2 と指定した場合，どれか一つの文書で頻度が二つ以上
##           のタームは，これ以外の各文書に一度しか出現していなくとも，
##           したがって，doc1という文書で二度以上出現しているタームが，
##           他の文書で一度しか出現していない場合，このタームは出力の
##           ターム．文書行列に含まれるが，doc1以外の文書の頻度は一律 0 にされる
##  weight 重みを付ける 標準的には "tf*idf*norm"を指定 
##  Genkei = 0 活用語を原型 (0) にするか，表層形(1) にするか

library(R2MeCab)

(res <- docDF("doc"))
res <- docDF("doc", type=1, N=1, co=1 ) 
(res <- docDF("doc", pos = c("名詞","形容詞","助詞"),N=1, type = 1))



   (res <- docMatrix("doc", pos = c("名詞","形容詞"), weight = "tf*idf"))# 参考
(res <- docDF("doc", N=1, type=1, weight = "tf*idf"))


   (res <- docMatrix("doc", pos = c("名詞","形容詞"), weight = "tf*idf*norm"))
   colSums(res^2)# 参考

(res <- docDF("doc", type = 1, weight = "tf*idf*norm"))
colSums(res[,4:6]^2)#各列とも二乗の合計は１
##  データに NA が含まれる場合や，minFreq 引数に 2 以上を指定した場合は出力には NA が含まれるので注意





(res <- docDF("doc", N=1))

(res <- docDF("doc", type = 1, N=1))
(res <- docDF("doc", type = 1, N=2))

(res <- docDF("doc", type = 1, pos = c("名詞","動詞"), N=1))
(res <- docDF("doc", type = 1, pos = c("名詞","動詞", "記号"),N=1))

(res <- docDF("doc", type = 1))

(res <- docDF("yukiguni.txt", type = 1))

(res <- docDF("yukiguni.txt", N= 1, type = 1))

# 時間がかかります．
res <- docDF("morikita", pos = c("名詞","形容詞"), type = 1, N=3))
nrow(res); ncol(res)


(target <- read.csv("photo.csv"))
(res <- docDF(target, col = 3))
(res <- docDF(target, col = 3, type = 1, N = 1,pos = c("名詞","動詞")))

(res <- docDF(target, N=1, col = 3))

(res <- docDF(target, col = 3,  type=1,pos = c("名詞")))

(res <- docDF(target, col = 3, type=1, N = 3))


(res <- docDF(target, col = 3,  type=1,pos = c("動詞")))

(res <- docDF(target, col = 3, type=1, pos = c("名詞","動詞","助詞")))


## 共起行列の作成
### 共起行列の作成は，非常にメモリを喰います．
### 例えば本書付属の wrinters フォルダから行列を作成する際，
### 同時に co 引数で共起行列への変換を指定すると
### １GB 程度のメモリのマシンではフリーズすることもあります．


## テキストの分量が大きく，行列が大きくなる場合は
## Matrix パッケージを利用したsparse 行列への変換をおすすめします
## 以下に例があります

(res <- docDF("doc", co = 1))

(res <- docDF("doc", co = 2))

## (res <- docDF("doc", co = 3))

# 時間がかかります．
res <- docDF("writers", type = 1,pos = c("名詞","形容詞","助詞"))
nrow(res); ncol(res)



##### 特に共起行列の作成は注意が必要です
 rm(list = ls())
 gc(); gc()

 pt1 <- proc.time()
 res <- docDF("writers", type = 1,pos = c("名詞","形容詞","助詞"), co =1)
 pt2 <- proc.time()
 pt2 - pt1
 ##    user  system elapsed 
 ##   4.744   0.984   5.932
 ## core2duo memory 4GB Ubuntu 8.10  R-2.8.1 


 nrow(res);ncol(res)


 library(Matrix)# Matrix パッケージを利用したsparse 行列への変換
 
 rm(list = ls())
 gc(); gc(); ls()
 pt1 <- proc.time()
 res <- docDF("writers", type = 1,pos = c("名詞","形容詞","助詞"))
 res <- Matrix(as.matrix( res[,  -c(1,2,3)] ))
 res0 <- crossprod(t(res > 0))
 pt2 <- proc.time()
 pt2 - pt1
 ##    user  system elapsed 
 ##   1.240   0.564   2.200
 ## core2duo memory 4GB Ubuntu 8.10  R-2.8.1 


